import { useEditor } from "@/modules/editor";
import { queenApi } from "queenjs";
import { string } from "vue-types";
import { createUIComp } from "../../defines/createUIComp";
import { useCompData } from ".";

export const Component = createUIComp({
  props: {
    compId: string(),
    value: string(),
  },
  emits: ["update:value"],
  setup(props, { emit }) {
    const comp = props.compId ? useCompData(props.compId) : null;
    const { store } = useEditor();
    async function changeVal() {
      const files = await queenApi.selectFile();
      const url = URL.createObjectURL(files[0]);
      if (comp) {
        comp.value = URL.createObjectURL(files[0]);
      } else {
        emit("update:value", url);
      }
    }
    return () => (
      <img
        class="w-1/1 h-1/1 object-cover"
        src={comp?.value || props.value}
        onClick={store.isEditMode ? changeVal : undefined}
      />
    );
  },
});
