import { css } from "@linaria/core";
import { queenApi } from "queenjs";
import { defineComponent } from "vue";
import { string } from "vue-types";

export const ImagePicker = defineComponent({
  props: {
    value: string(),
  },
  emits: ["change"],
  setup(props, { emit }) {
    async function changeVal() {
      const [file] = await queenApi.selectFile({ accept: "image/*" });
      emit("change", URL.createObjectURL(file));
    }

    return () => (
      <div class={imageStyle} onClick={changeVal}>
        {props.value ? <img src={props.value} /> : <i>＋</i>}
      </div>
    );
  },
});

const imageStyle = css`
  width: 1.2rem;
  height: 1.2rem;
  padding: 0.12rem;
  text-align: center;
  line-height: 1.2rem;
  border: 1px dashed @inf-text-less-color;
  border-radius: 4px;
  box-sizing: content-box;
  cursor: pointer;

  img {
    width: 100%;
    height: 100%;
    object-fit: contain;
  }
  i {
    font-style: unset;
    font-size: 0.72rem;
  }
`;
